import { IMap } from '../extensions';
interface IFrom<E extends IMap = IMap, P extends IMap = IMap> {
    env: {
        mode: string;
        <K extends keyof E>(name: K): string;
        <K extends keyof E, V>(name: K, format: (value: string) => V): V;
        <K extends keyof E>(name: K, defaultValue: E[K]): E[K];
        <K extends keyof E, V>(name: K, format: (value: string) => V, defaultValue: V): V;
    };
    packageJson: {
        title: string;
        version: string;
        <K extends keyof P>(name: K): P[K];
        <K extends keyof P, V>(name: K, format: (value: P[K]) => V): V;
        <K extends keyof P>(name: K, defaultValue: P[K]): P[K];
        <K extends keyof P, V>(name: K, format: (value: P[K]) => V, defaultValue: V): V;
    };
}
interface IConfig<E extends IMap = IMap, P extends IMap = IMap> {
    maxSearchDepthForJSONFiles?: number;
    environmentVariableKeys: E;
    packageJsonKeys: P;
}
export declare function createSettings<T extends IMap, E extends IMap, P extends IMap>(config: IConfig<E, P>, delegate: (from: IFrom<E, P>) => T): T;
export {};
